#!/usr/bin/env node
'use strict';
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = require("fs");
var path_1 = require("path");
var debug_helper_1 = require("./util/debug_helper");
var _a = debug_helper_1.default(__filename), print = _a.print, logError = _a.logError;
var _b = process.argv, arg = _b[2];
if (/\s-v.*/.test(arg)) {
    try {
        var _c = JSON.parse(fs_1.readFileSync(path_1.resolve(__dirname, '..', 'package.json')).toString()), name_1 = _c.name, version_1 = _c.version;
        console.log("    " + name_1 + " v" + version_1 + " \u2714\uFE0F");
    }
    catch (error) {
        logError({ error: error });
    }
    process.exit();
}
if (/\s-dotenv.*/.test(arg)) {
    require('dotenv').config();
}
var private_api_request_1 = require("./api_clients/kraken/private_api_request");
var private_api_request_2 = require("./api_clients/hitbtc/private_api_request");
var private_api_request_3 = require("./api_clients/binance/private_api_request");
var nodeMenu = require("node-menu");
var filter_balances_1 = require("./util/filter_balances");
var handle_user_input_1 = require("./util/handle_user_input");
var get_last_price_1 = require("./services/hitbtc/get_last_price");
var get_last_price_2 = require("./services/binance/get_last_price");
var get_last_price_3 = require("./services/kraken/get_last_price");
var pkgPath = path_1.resolve(__dirname, '..', 'package.json');
var version = JSON.parse(fs_1.readFileSync(pkgPath).toString()).version;
nodeMenu
    .customHeader(function () {
    process.stdout.write("                              <<<<<<     TS-CRYPTO-CLI v" + version + "     >>>>>>\n\n");
})
    .addDelimiter('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n#    Kraken API | https://www.kraken.com/features/api#general-usage\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~', 2)
    .addItem('PUBLIC API request', function (input) { handle_user_input_1.default(input, 'kraken', 'public'); }, null, [{ name: '<endpoint>;<query>', type: 'string' }])
    .addItem('PRIVATE API request', function (input) { handle_user_input_1.default(input, 'kraken', 'private'); }, null, [{ name: '<endpoint>;<query>', type: 'string' }])
    .addItem('Get latest PRICE ticker', function (symbol) { return __awaiter(void 0, void 0, void 0, function () { var _a; return __generator(this, function (_b) {
    switch (_b.label) {
        case 0:
            _a = print;
            return [4 /*yield*/, get_last_price_3.getKrakenLastPrice(symbol)];
        case 1:
            _a.apply(void 0, [_b.sent()]);
            return [2 /*return*/];
    }
}); }); }, null, [{ name: '<symbol>', type: 'string' }])
    .addItem('Show Balances', function () { return __awaiter(void 0, void 0, void 0, function () { var _a; return __generator(this, function (_b) {
    switch (_b.label) {
        case 0:
            _a = print;
            return [4 /*yield*/, private_api_request_1.krakenPrivateApiRequest({ url: 'Balance' })];
        case 1:
            _a.apply(void 0, [_b.sent()]);
            return [2 /*return*/];
    }
}); }); })
    .addItem('BUY @ market', function (pair, volume) { return __awaiter(void 0, void 0, void 0, function () { var _a; return __generator(this, function (_b) {
    switch (_b.label) {
        case 0:
            _a = print;
            return [4 /*yield*/, private_api_request_1.krakenPrivateApiRequest({ url: 'AddOrder', data: { pair: pair, type: 'buy', ordertype: 'market', volume: volume } })];
        case 1:
            _a.apply(void 0, [_b.sent()]);
            return [2 /*return*/];
    }
}); }); }, null, [{ name: '<pair>', type: 'string' }, { name: '<amount>', type: 'numeric' }])
    .addItem('SELL @ market', function (pair, volume) { return __awaiter(void 0, void 0, void 0, function () { var _a; return __generator(this, function (_b) {
    switch (_b.label) {
        case 0:
            _a = print;
            return [4 /*yield*/, private_api_request_1.krakenPrivateApiRequest({ url: 'AddOrder', data: { pair: pair, type: 'sell', ordertype: 'market', volume: volume } })];
        case 1:
            _a.apply(void 0, [_b.sent()]);
            return [2 /*return*/];
    }
}); }); }, null, [{ name: '<pair>', type: 'string' }, { name: '<amount>', type: 'numeric' }])
    .addDelimiter(' ', 1)
    .addDelimiter('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n#    HitBTC API | https://api.hitbtc.com/#rest-api-reference\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~', 2)
    .addItem('PUBLIC API request', function (input) { handle_user_input_1.default(input, 'hitbtc', 'public'); }, null, [{ name: '<endpoint>;<method>;<query>', type: 'string' }])
    .addItem('PRIVATE API request', function (input) { handle_user_input_1.default(input, 'hitbtc', 'private'); }, null, [{ name: '<endpoint>;<method>;<query>', type: 'string' }])
    .addItem('Get PRICE ticker', function (symbol) { return __awaiter(void 0, void 0, void 0, function () { var _a; return __generator(this, function (_b) {
    switch (_b.label) {
        case 0:
            _a = print;
            return [4 /*yield*/, get_last_price_1.getHitBTCLastPrice(symbol)];
        case 1:
            _a.apply(void 0, [_b.sent()]);
            return [2 /*return*/];
    }
}); }); }, null, [{ name: '<symbol>', type: 'string' }])
    .addItem('Show ACCOUNT Balances', function () { return __awaiter(void 0, void 0, void 0, function () { var _a; return __generator(this, function (_b) {
    switch (_b.label) {
        case 0:
            _a = filter_balances_1.default;
            return [4 /*yield*/, private_api_request_2.hitbtcPrivateApiRequest({ url: 'account/balance' })];
        case 1:
            _a.apply(void 0, [_b.sent()]);
            return [2 /*return*/];
    }
}); }); })
    .addItem('Show TRADING Balances', function () { return __awaiter(void 0, void 0, void 0, function () { var _a; return __generator(this, function (_b) {
    switch (_b.label) {
        case 0:
            _a = filter_balances_1.default;
            return [4 /*yield*/, private_api_request_2.hitbtcPrivateApiRequest({ url: 'trading/balance' })];
        case 1:
            _a.apply(void 0, [_b.sent()]);
            return [2 /*return*/];
    }
}); }); })
    .addItem('BUY @ market', function (symbol, quantity) { return __awaiter(void 0, void 0, void 0, function () { var _a; return __generator(this, function (_b) {
    switch (_b.label) {
        case 0:
            _a = print;
            return [4 /*yield*/, private_api_request_2.hitbtcPrivateApiRequest({ url: 'order', method: 'POST', data: { symbol: symbol, side: 'buy', type: 'market', quantity: quantity } })];
        case 1:
            _a.apply(void 0, [_b.sent()]);
            return [2 /*return*/];
    }
}); }); }, null, [{ name: '<pair>', type: 'string' }, { name: '<amount>', type: 'numeric' }])
    .addItem('SELL @ market', function (symbol, quantity) { return __awaiter(void 0, void 0, void 0, function () { var _a; return __generator(this, function (_b) {
    switch (_b.label) {
        case 0:
            _a = print;
            return [4 /*yield*/, private_api_request_2.hitbtcPrivateApiRequest({ url: 'order', method: 'POST', data: { symbol: symbol, side: 'sell', type: 'market', quantity: quantity } })];
        case 1:
            _a.apply(void 0, [_b.sent()]);
            return [2 /*return*/];
    }
}); }); }, null, [{ name: '<pair>', type: 'string' }, { name: '<amount>', type: 'numeric' }])
    .addDelimiter(' ', 1)
    .addDelimiter('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n#    Binance API | https://binance-docs.github.io/apidocs/spot/en/#general-api-information\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~', 2)
    .addItem('PUBLIC API request', function (input) { handle_user_input_1.default(input, 'binance', 'public'); }, null, [{ name: '<endpoint>;<method>;<query>', type: 'string' }])
    .addItem('PRIVATE API request', function (input) { handle_user_input_1.default(input, 'binance', 'private'); }, null, [{ name: '<endpoint>;<method>;<query>', type: 'string' }])
    .addItem('Get PRICE ticker', function (symbol) { return __awaiter(void 0, void 0, void 0, function () { var _a; return __generator(this, function (_b) {
    switch (_b.label) {
        case 0:
            _a = print;
            return [4 /*yield*/, get_last_price_2.getBinanceLastPrice(symbol)];
        case 1:
            _a.apply(void 0, [_b.sent()]);
            return [2 /*return*/];
    }
}); }); }, null, [{ name: '<symbol>', type: 'string' }])
    .addItem('Show Balances', function () { return __awaiter(void 0, void 0, void 0, function () { var _a; return __generator(this, function (_b) {
    switch (_b.label) {
        case 0:
            _a = filter_balances_1.default;
            return [4 /*yield*/, private_api_request_3.binancePrivateApiRequest({ url: 'api/v3/account' })];
        case 1:
            _a.apply(void 0, [(_b.sent()).balances]);
            return [2 /*return*/];
    }
}); }); })
    .addItem('BUY @ market', function (symbol, quantity) { return __awaiter(void 0, void 0, void 0, function () { var _a; return __generator(this, function (_b) {
    switch (_b.label) {
        case 0:
            _a = print;
            return [4 /*yield*/, private_api_request_3.binancePrivateApiRequest({ url: 'api/v3/order', method: 'POST', data: { symbol: symbol, side: 'buy', type: 'market', quantity: quantity } })];
        case 1:
            _a.apply(void 0, [_b.sent()]);
            return [2 /*return*/];
    }
}); }); }, null, [{ name: '<pair>', type: 'string' }, { name: '<amount>', type: 'numeric' }])
    .addItem('SELL @ market', function (symbol, quantity) { return __awaiter(void 0, void 0, void 0, function () { var _a; return __generator(this, function (_b) {
    switch (_b.label) {
        case 0:
            _a = print;
            return [4 /*yield*/, private_api_request_3.binancePrivateApiRequest({ url: 'api/v3/order', method: 'POST', data: { symbol: symbol, side: 'sell', type: 'market', quantity: quantity } })];
        case 1:
            _a.apply(void 0, [_b.sent()]);
            return [2 /*return*/];
    }
}); }); }, null, [{ name: '<pair>', type: 'string' }, { name: '<amount>', type: 'numeric' }])
    .addDelimiter(' ', 1)
    .customPrompt(function () {
    process.stdout.write('\nEnter your selection:\n');
})
    .continueCallback(function () {
    // Runs between 'Press enter to continue' and the new menu render
})
    .start();
